
; => a0 : actor
Actor_Create:
 move.l d0,-(a7)
 lea Actors(a6),a0
 moveq #(MAX_ACTIVE_ACTORS-1),d0
\0:
 btst #AF_INUSE,A_Flags(a0)
 beq \2
 add.w #sACTOR,a0
 dbra d0,\0
\1:
 bra \1 
\2:
 moveq #((sACTOR/2)-1),d0
\3:
 clr.w (a0)+
 dbra d0,\3
 sub.w #sACTOR,a0
 bset #AF_INUSE,A_Flags(a0)
 move.l (a7)+,d0 
 rts

Actors_Update:
 lea Actors(a6),a5
 move.w #(MAX_ACTORS-1),d7
\0:
 btst #AF_INUSE,A_Flags(a5)
 beq \99
 move.w d7,-(a7)
 move.w #0,a0
 cmp.w #(MAX_ACTORS-1),d7
 bne \1
 move.l pPlatForm(a6),a0
\1:
 moveq #1,d4
 move.l a5,a1
\2: 
 move.l A_x(a1),d0
 add.l A_XSpeed(a1),d0
 cmp.w #0,a0
 beq \4
 tst.b d4
 beq \3
 add.l A_XSpeed(a0),d0
 bra \4
\3:
 move.w A_y(a0),d0
 sub.w A_Height(a5),d0
 swap d0
\4:
 move.l d0,A_x(a1)
 btst #AF_COLLISION_ITEMS,A_Flags(a5)
 beq \21
 
 lea Room(a6),a3

 move.w A_x(a5),d7
 move.w d7,d0
 lsr.w #3,d0
 add.w A_Width(a5),d7
 addq.w #7,d7
 lsr.w #3,d7
 sub.w d0,d7
 subq.w #1,d7
 add.w d0,a3

 move.w A_y(a5),d6
 move.w d6,d0
 asr.w #3,d0
 add.w A_Height(a5),d6
 addq.w #7,d6
 asr.w #3,d6
 sub.w d0,d6
 subq.w #1,d6
 muls.w wRoomWidth(a6),d0
 add.w d0,a3

\10:
 lea Room(a6),a2
 cmp.l a2,a3
 blt \11_
 move.l a3,a2
 move.w d7,d5
\11:
 cmp.b #128,(a2)+
 bhi \12
 dbra d5,\11
\11_:
 add.w wRoomWidth(a6),a3
 dbra d6,\10
 clr.b d0
 bra \20
\12:
 tst.l A_XSpeed(a1)
 bgt \13
 move.w A_x(a1),d0
 addq.w #8,d0
 and.w #$fff8,d0
 swap d0
 clr.w d0
 move.l d0,A_x(a1)
 move.b #1,d0
 bra \20
\13:
 move.w A_x(a1),d0
 add.w A_Width(a1),d0
 and.w #$fff8,d0
 sub.w A_Width(a1),d0
 swap d0
 clr.w d0
 move.l d0,A_x(a1)
 move.b #2,d0
\20:
 move.b d0,bCollisionY(a6,d4.w)
\21:
 addq.w #4,a1
 dbra d4,\2

 cmp.w #0,a0
 beq \23
 cmp.b #2,bCollisionY(a6)
 bne \22
 clr.l pPlatForm(a6)
\22: 
 move.b #2,bCollisionY(a6)
\23:

 cmp.w #(MAX_ACTORS-1),(a7)
 beq \25 
 move.w A_x(a5),d0
 add.w A_Width(a5),d0
 cmp.w wScrollingX(a6),d0
 ble \24
 move.w A_y(a5),d0
 add.w A_Height(a5),d0
 cmp.w #-5,d0
 ble \24
 cmp.w #100,A_y(a5)
 blt \25
\24:
 bclr #AF_INUSE,A_Flags(a5)
 bra \98
\25:
 clr.l pCollisionActor(a6)
 lea Actors(a6),a0
 moveq #(MAX_ACTIVE_ACTORS-1),d0
 move.w A_x(a5),d1
 move.w d1,d2
 add.w A_Width(a5),d2
 move.w A_y(a5),d3
 move.w d3,d4
 add.w A_Height(a5),d4
 btst #AF_COLLISION_ACTORS,A_Flags(a5)
 bne \30
 clr.w d0
\30:
 cmp.l a0,a5 
 beq \39
 move.w A_x(a0),d5
 cmp.w d5,d2
 ble \39
 add.w A_Width(a0),d5
 cmp.w d5,d1
 bge \39
 move.w A_y(a0),d5
 cmp.w d5,d4
 ble \39
 add.w A_Height(a0),d5
 cmp.w d5,d3
 bge \39
 move.l a0,pCollisionActor(a6)
\39: 
 add.w #sACTOR,a0
 dbra d0,\30

 move.l A_pUpdate(a5),a0
 jsr (a0)
\98:
 move.w (a7)+,d7
\99:
 add.w #sACTOR,a5
 dbra d7,\0
 rts
 
Mario_Update:
 tst.l uTime(a6)
 bgt \0
 bset #GF_TIME_UP,bGameFlags(a6)
 bra \MarioDie
\0:
 move.w wScrollingX(a6),d0
 cmp.w A_x(a5),d0
 blt \10
 move.w d0,A_x(a5)
\10:
 cmp.w #92,A_y(a5)
 bgt \MarioDie
 
 move.b bKeys(a6),d1
 clr.l d0
 btst #3,d1
 bne \20
 bclr #AS_DIRECTION,A_State(a5)
 move.l #40000,d0
\20:
 btst #1,d1
 bne \21
 bset #AS_DIRECTION,A_State(a5)
 move.l #-40000,d0
\21:
 move.l d0,A_XSpeed(a5)

 move.l A_YSpeed(a5),d0
 add.l #6000,d0
 btst #4,d1
 bne \30
 tst.l d0
 bge \30
 sub.l #3500,d0
\30: 
 cmp.l #180000,d0
 blt \31
 move.l #180000,d0
\31:
 cmp.l #-180000,d0
 bgt \32
 move.l #-180000,d0
\32: 
 btst #4,d1
 bne \33
 btst #4,bLastKeys(a6)
 beq \33
 cmp.b #2,bCollisionY(a6)
 bne \33
 move.l #-100000,d0
\33:
 cmp.b #1,bCollisionY(a6)
 bne \34
 neg.l d0
\34:
 move.l d0,A_YSpeed(a5)
 
 move.w A_Data(a5),d0
 bne \40
 btst #AS_DAMAGED,A_State(a5)
 beq \50
 bclr #AS_CAN_FIRE,A_State(a5)
 btst #AS_BIG,A_State(a5)
 bne \39
\MarioDie:
 lea Mario_Die(pc),a0
 move.l a0,A_pUpdate(a5) 
 move.l #-50000,A_YSpeed(a5)
 clr.l A_XSpeed(a5)
 bclr #AF_COLLISION_ITEMS,A_Flags(a5)
 bra \50
\39:
 move.w #500,A_Data+2(a5)
 move.w #300,d0
\40: 
 move.w d0,d1
 subq.w #1,d0
 move.w d0,A_Data(a5)
 beq \45
 eor.w d1,d0
 btst #4,d0
 beq \50
 bchg #AS_BIG,A_State(a5)
 beq \42
\41:
 subq.w #8,A_Height(a5)
 addq.w #8,A_y(a5)
 bra \50
\42:
 addq.w #8,A_Height(a5)
 subq.w #8,A_y(a5)
 bra \50
\45:
 bclr #AS_DAMAGED,A_State(a5)
 beq \46
 bclr #AS_BIG,A_State(a5)
 beq \50
 bra \41
\46: 
 bset #AS_BIG,A_State(a5)
 beq \42
\50: 

 move.w A_x(a5),d6
 move.w A_y(a5),d7
 btst #6,bKeys(a6)
 bne \60
 btst #AS_CAN_FIRE,A_State(a5)
 beq \60
 bset #AF_INUSE,A_Flags+Bullet(a6)
 bne \60
 lea Bullet_Update(pc),a0
 move.l a0,A_pUpdate+Bullet(a6)
 or.b #(AFS_COLLISION_ITEMS+AFS_COLLISION_ACTORS),A_Flags+Bullet(a6)
 move.w d6,A_x+Bullet(a6)
 move.w d7,A_y+Bullet(a6)
 move.w #8,A_Width+Bullet(a6)
 move.w #8,A_Height+Bullet(a6)
 move.l #-50000,A_XSpeed+Bullet(a6)
 move.l #50000,A_YSpeed+Bullet(a6)
 btst #AS_DIRECTION,A_State(a5)
 bne \60
 neg.l A_XSpeed+Bullet(a6)
\60:
 btst #AS_BIG,A_State(a5)
 beq \80
 lea MarioBigStandRight(pc),a4
 cmp.b #2,bCollisionY(a6)
 beq \75
 tst.l A_YSpeed(a5)
 bgt \90
 lea MarioBigJumpRight(pc),a4
 bra \90
\75:
 tst.l A_XSpeed(a5)
 beq \90
 move.w uTime+2(a6),d0
 and.w #%11000,d0
 lsl.w #3,d0
 add.w d0,a4
 bra \90 
\80: 
 subq.w #8,d7
 lea MarioStandRight(pc),a4
 cmp.b #2,bCollisionY(a6)
 beq \85
 tst.l A_YSpeed(a5)
 bgt \90
 lea MarioJumpRight(pc),a4
 bra \90
\85:
 tst.l A_XSpeed(a5)
 beq \90
 move.w uTime+2(a6),d0
 and.w #%11000,d0
 lsl.w #3,d0
 add.w d0,a4
\90:   
 move.b A_State(a5),d0
 and.w #ASS_DIRECTION,d0
 add.w d0,a4
 move.w A_Data+2(a5),d0
 beq \99
 subq.w #1,d0
 bne \91
 bclr #AS_INVICIBLE,A_State(a5)
\91:
 move.w d0,A_Data+2(a5)
 btst #3,d0
 beq \99
 rts
\99: 
 bra Sprite2x2_Draw

Mario_WarpPipeVertUp_Update:
 add.w #60,A_Data(a5)
 move.w A_Data(a5),d0
 lsr.w #8,d0
 cmp.b #16,d0
 bpl \9 
 lea -32(a7),a7
 move.l a7,a0
 move.w d0,d1
\0: 
 clr.b 16(a0)
 clr.b (a0)+
 dbra d1,\0
 neg.w d0
 add.w #14,d0
 blt \2
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea MarioBigStandRight(pc),a1
 btst #AS_BIG,A_State(a5)
 bne \1
 lea MarioStandRight(pc),a1
 subq.w #8,d7
\1:
 move.b 16(a1),16(a0)
 move.b (a1)+,(a0)+
 dbra d0,\1
\2:
 move.l a7,a4
 bsr Sprite2x2_Draw
 lea 32(a7),a7
 rts
\9:
 bset #GF_ROOM_LOAD,bGameFlags(a6)
 rts

Mario_WarpPipeHorizLeft_Update:
 add.w #60,A_Data(a5)
 move.w A_Data(a5),d0
 lsr.w #8,d0
 cmp.b #8,d0
 bhi \9 
 lea -32(a7),a7
 move.l a7,a0
 moveq #15,d1
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea MarioBigStandRight(pc),a1
 btst #AS_BIG,A_State(a5)
 bne \0
 subq.w #8,d7
 lea MarioStandRight(pc),a1
\0:
 clr.b 16(a0)
 move.b (a1)+,d2
 lsr.b d0,d2 
 move.b d2,(a0)+
 dbra d1,\0 
 move.l a7,a4
 bsr Sprite2x2_Draw
 lea 32(a7),a7
 rts
\9:
 bset #GF_ROOM_LOAD,bGameFlags(a6)
 rts

Mario_WarpDoor_Update:
 bset #GF_ROOM_LOAD,bGameFlags(a6)
 rts

Mario_Die:
 tst.l A_YSpeed(a5)
 bgt \0
 cmp.w #10,A_y(a5)
 bgt \90
 neg.l A_YSpeed(a5)
 bra \90
\0: 
 cmp.w #95,A_y(a5)
 blt \90
 subq.w #1,wLives(a6)
 bne \80
 bset #GF_GAME_OVER,bGameFlags(a6)
\80:
 bset #GF_ROOM_LOAD,bGameFlags(a6)
 move.l pWarpSave(a6),pWarp(a6)
\90:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea MarioDie0(pc),a4
 bra Sprite2x2_Draw
 rts

PlatForm001_Update:
 btst #AF_COLLISION_ITEMS,A_Flags+Actors(a6)
 bne \0
 clr.l pPlatForm(a6)
 bra \20
\0:
 tst.l pPlatForm(a6)
 beq \10
 cmp.l pPlatForm(a6),a5
 bne \19
 tst.l A_YSpeed+Actors(a6)
 blt \9
 move.w A_x+Actors(a6),d0
 move.w A_x(a5),d1
 add.w A_Width+Actors(a6),d0
 cmp.w d1,d0
 ble \9
 add.w A_Width(a5),d1
 cmp.w A_x+Actors(a6),d1
 bgt \19
\9:
 clr.l pPlatForm(a6)
 bra \19
\10:
 tst.l pCollisionActor(a6)
 beq \19
 tst.l A_YSpeed+Actors(a6)
 blt \19
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w A_y(a5),d0
 cmp.w #3,d0
 bgt \19
 move.l a5,pPlatForm(a6)
\19: 
 subq.w #1,A_Data+2(a5)
 bgt \20
 move.w A_Data+4(a5),A_Data+2(a5)
 neg.l A_XSpeed(a5)
 neg.l A_YSpeed(a5)
\20:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 move.w A_Data(a5),d2
\30: 
 lea PlatForm001(pc),a4
 bsr Sprite_Draw
 addq.w #8,d6
 dbra d2,\30
 rts

BlockFalling_Update:
 tst.l pPlatForm(a6)
 beq \10
 cmp.l pPlatForm(a6),a5
 bne \19
 tst.l A_YSpeed+Actors(a6)
 blt \9
 move.w A_x+Actors(a6),d0
 add.w A_Width+Actors(a6),d0
 move.w A_x(a5),d1
 cmp.w d1,d0
 ble \9
 add.w #8,d1
 cmp.w A_x+Actors(a6),d1
 bgt \19
\9:
 clr.l pPlatForm(a6)
 bra \19
\10:
 tst.l pCollisionActor(a6)
 beq \19
 tst.l A_YSpeed+Actors(a6)
 blt \19
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w A_y(a5),d0
 cmp.w #3,d0
 bgt \19
 move.l a5,pPlatForm(a6)
 tst.w A_Data(a5)
 bne \19
 move.w #20,A_Data(a5)
\19: 
 tst.w A_Data(a5)
 beq \20
 subq.w #1,A_Data(a5)
 bne \20
 move.l #$6000,A_YSpeed(a5)
\20:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea BlockFalling(pc),a4
 bra Sprite_Draw

BlockPowerUp_Jump:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 move.l A_Data(a5),a4
 bsr Sprite_Draw
 subq.b #1,A_Data+9(a5)
 bne \0
 bclr #AF_INUSE,A_Flags(a5)
 move.l A_Data+4(a5),a0
 move.b #242,-1(a0)
\0:
 cmp.b #15,A_Data+9(a5)
 beq \1
 rts
\1:
 neg.l A_YSpeed(a5)
 move.b A_Data+8(a5),d5
 cmp.b #217,d5
 beq \10
 cmp.b #221,d5
 bne \20
\10:
 addq.w #1,wCoins(a6)
 lea CoinAnim(a6),a0
 bset #AF_INUSE,A_Flags(a0)
 lea CoinAnim_Update(pc),a1
 move.l a1,A_pUpdate(a0)
 move.w d6,A_x(a0)
 move.w d7,A_y(a0)
 move.l #-20000,A_YSpeed(a0)
 move.b #60,A_Data(a0)
 rts
\20:
 cmp.b #216,d5
 beq \21
 cmp.b #219,d5
 bne \30
\21:
 lea Mushroom(pc),a1
 moveq #1,d5
 btst #AS_BIG,A_State+Actors(a6)
 beq \32
 bsr Actor_Create
 lea Flower_Update(pc),a1
 move.l a1,A_pUpdate(a0)
 move.w d6,A_x(a0)
 move.w d7,A_y(a0)
 move.w #8,A_Width(a0)
 move.w #8,A_Height(a0)
 rts
\30:
 cmp.b #214,d5
 beq \31
 cmp.b #215,d5
 bne \40
\31:
 lea Heart(pc),a1
 clr.b d5
\32:
 bsr PowerUpSolidMoving_Create
 rts
\40:
 bsr Actor_Create
 lea Star_Update(pc),a1
 move.l a1,A_pUpdate(a0)
 move.w d6,A_x(a0)
 move.w d7,A_y(a0)
 move.w #8,A_Width(a0)
 move.w #8,A_Height(a0)
 move.l #100000,A_XSpeed(a0)
 move.l #-50000,A_YSpeed(a0)
 rts

Debris_Update:
 move.l A_YSpeed(a5),d0
 add.l #6000,d0
 cmp.l #50000,d0
 blt \1
 move.l #50000,d0
\1:
 move.l d0,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 move.l A_Data(a5),a4
 bra Sprite_Draw

CoinAnim_Update:
 subq.b #1,A_Data(a5)
 bne \0
 bclr #AF_INUSE,A_Flags(a5)
\0:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea Coin0(pc),a4
 move.w uTime+2(a6),d0
 and.w #$18,d0
 add.w d0,a4
 bra Sprite_Draw

; (d6.w,d7.w) : (x,y)
; a1 : sprite
; d5.b : 0 = 1up
PowerUpSolidMoving_Create:
 bsr Actor_Create
 move.l a1,A_Data(a0)
 move.b d5,A_Data+4(a0)
 lea PowerUpSolidMoving_Update(pc),a1
 move.l a1,A_pUpdate(a0)
 bset #AF_COLLISION_ITEMS,A_Flags(a0)
 move.w d6,A_x(a0)
 move.w d7,A_y(a0)
 move.w #8,A_Width(a0)
 move.w #8,A_Height(a0)
 move.l #20000,A_XSpeed(a0)
 move.l #-10000,A_YSpeed(a0)
 rts
 
PowerUpSolidMoving_Update:
 move.l A_XSpeed(a5),d0
 move.l A_YSpeed(a5),d1
 tst.b bCollisionX(a6)
 beq \0
 neg.l d0
\0: 
 add.l #3000,d1
 cmp.l #30000,d1
 blt \10
 move.l #30000,d1
\10:
 move.l d0,A_XSpeed(a5)
 move.l d1,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 tst.l pCollisionActor(a6)
 beq \30
 bclr #AF_INUSE,A_Flags(a5)
 tst.b A_Data+4(a5)
 beq \20
 bsr FloatingScore1000_Create
 move.w #300,A_Data+Actors(a6)
 bra \30
\20:
 bsr FloatingScore1Up_Create
\30:
 move.l A_Data(a5),a4
 bra Sprite_Draw

Star_Update:
 move.l A_YSpeed(a5),d1
 tst.l d1
 blt \0
 clr.l A_XSpeed(a5)
\0:
 add.l #3000,d1
 cmp.l #30000,d1
 blt \10
 move.l #30000,d1
\10:
 move.l d1,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 tst.l pCollisionActor(a6)
 beq \20
 bsr FloatingScore1000_Create
 bclr #AF_INUSE,A_Flags(a5)
 bset #AS_INVICIBLE,A_State+Actors(a6)
 move.w #800,A_Data+2+Actors(a6)
\20:
 lea Star(pc),a4
 bra Sprite_Draw

Flower_Update:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 tst.l pCollisionActor(a6)
 beq \20
 bsr FloatingScore1000_Create
 bclr #AF_INUSE,A_Flags(a5)
 bset #AS_CAN_FIRE,A_State+Actors(a6)

 
\20:
 lea Flower0(pc),a4
 move.w uTime+2(a6),d0
 and.w #8,d0
 add.w d0,a4
 bra Sprite_Draw

Gombas_Update:
 move.l A_XSpeed(a5),d0
 move.l A_YSpeed(a5),d1
 tst.b bCollisionX(a6)
 beq \0
 neg.l d0
\0: 
 add.l #3000,d1
 cmp.l #30000,d1
 blt \10
 move.l #30000,d1
\10:
 move.l d0,A_XSpeed(a5)
 move.l d1,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 bclr #AS_DAMAGED,A_State(a5)
 bne \15
 tst.l pCollisionActor(a6)
 beq \30
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w A_y(a5),d0
 cmp.w #3,d0
 bgt \20
 tst.l A_YSpeed+Actors(a6)
 blt \20
 move.l #-100000,A_YSpeed+Actors(a6)
\15:
 bsr FloatingScore100_Create
 bclr #AF_INUSE,A_Flags(a5)
 move.b #(AFS_INUSE+AFS_COLLISION_ITEMS),A_Flags+DeadEnemy(a6)
 lea GombasDead_Update(pc),a0
 move.l a0,A_pUpdate+DeadEnemy(a6)
 move.w d6,A_x+DeadEnemy(a6)
 move.w d7,A_y+DeadEnemy(a6)
 clr.l A_XSpeed+DeadEnemy(a6)
 move.l #20000,A_YSpeed+DeadEnemy(a6)
 move.w #16,A_Width+DeadEnemy(a6)
 move.w #8,A_Height+DeadEnemy(a6)
 bra \30
\20:
 btst #AS_INVICIBLE,A_State+Actors(a6)
 bne \15
 tst.w A_Data+2+Actors(a6)
 bne \30
 bset #AS_DAMAGED,A_State+Actors(a6)
\30:
 lea Gombas0(pc),a4
 move.w uTime+2(a6),d0
 and.w #$40,d0
 lsr.w #3,d0
 add.w d0,a4
 bra Sprite_Draw

GombasDead_Update:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea GombasDead(pc),a4
 bra Sprite_Draw

Turtle_Update:
 move.l A_XSpeed(a5),d0
 tst.b bCollisionY(a6)
 bne \0
 sub.l d0,A_x(a5)
 move.l A_YSpeed(a5),d1
 sub.l d1,A_y(a5)
 neg.l d0
\0:
 tst.b bCollisionX(a6)
 beq \1
 neg.l d0
\1: 
 move.l d0,A_XSpeed(a5)

 move.w A_x(a5),d6
 move.w A_y(a5),d7
 bclr #AS_DAMAGED,A_State(a5)
 bne \15
 tst.l pCollisionActor(a6)
 beq \30
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w A_y(a5),d0
 cmp.w #3,d0
 bgt \20
 tst.l A_YSpeed+Actors(a6)
 blt \20
 move.l #-100000,A_YSpeed+Actors(a6)
\15:
 bsr FloatingScore100_Create
 bclr #AF_INUSE,A_Flags(a5)
 move.b #(AFS_INUSE+AFS_COLLISION_ITEMS),A_Flags+DeadEnemy(a6)
 lea TurtleDead_Update(pc),a0
 move.l a0,A_pUpdate+DeadEnemy(a6)
 move.w d6,A_x+DeadEnemy(a6)
 move.w d7,A_y+DeadEnemy(a6)
 addq.w #8,A_y+DeadEnemy(a6)
 clr.l A_XSpeed+DeadEnemy(a6)
 move.l #20000,A_YSpeed+DeadEnemy(a6)
 move.w #8,A_Width+DeadEnemy(a6)
 move.w #8,A_Height+DeadEnemy(a6)
 move.w #300,A_Data+DeadEnemy(a6)
 bra \30
\20:
 btst #AS_INVICIBLE,A_State+Actors(a6)
 bne \15
 tst.w A_Data+2+Actors(a6)
 bne \30
 bset #AS_DAMAGED,A_State+Actors(a6)
\30:

 lea Turtle0Right(pc),a4
 move.w uTime+2(a6),d0
 and.w #$40,d0
 lsr.w #1,d0
 add.w d0,a4
 tst.l A_XSpeed(a5)
 bge \31
 add.w #$10,a4
\31:
 bra Sprite2x1_Draw

TurtleDead_Update:
 subq.w #1,A_Data(a5)
 bne \0
 bclr #AF_INUSE,A_Flags(a5)
\0:

 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea TurtleDead(pc),a4
 cmp.w #120,A_Data(a5)
 bmi \10
 bra Sprite_Draw
\10:
 tst.l pCollisionActor(a6)
 beq \20
 tst.w A_Data+2+Actors(a6)
 bne \20
 bset #AS_DAMAGED,A_State+Actors(a6)
\20:
 lea Explosion0(pc),a4
 move.w A_Data(a5),d0
 and.w #$10,d0
 add.w d0,a4
 bclr #AF_COLLISION_ITEMS,A_Flags(a5)
 clr.l A_YSpeed(a5)
 move.w #16,A_Width(a5)
 bra Sprite1x2_Draw
 
GrassHopper_Update:
 move.l A_YSpeed(a5),d1
 cmp.b #1,bCollisionY(a6)
 bne \0
 neg.l d1
 bra \10
\0:
 cmp.b #2,bCollisionY(a6)
 bne \10
 clr.l d2
 move.w A_Data(a5),d0
 bne \9
 move.l #-100000,d1
 move.l #30000,d2
 move.w #120,d0
 bsr Random
 add.w #20,d0 
 move.w A_x+Actors(a6),d4
 cmp.w A_x(a5),d4
 bge \9
 neg.l d2
\9:
 subq.w #1,d0
 move.l d2,A_XSpeed(a5)
 move.w d0,A_Data(a5)
\10:
 add.l #3000,d1
 cmp.l #100000,d1
 blt \11
 move.l #100000,d1
\11: 
 move.l d1,A_YSpeed(a5)

 move.w A_x(a5),d6
 move.w A_y(a5),d7
 bclr #AS_DAMAGED,A_State(a5)
 bne \15
 tst.l pCollisionActor(a6)
 beq \30
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w A_y(a5),d0
 cmp.w #3,d0
 bgt \20
 tst.l A_YSpeed+Actors(a6)
 blt \20
 move.l #-100000,A_YSpeed+Actors(a6)
\15:
 bsr FloatingScore400_Create
 bclr #AF_INUSE,A_Flags(a5)
 move.b #(AFS_INUSE+AFS_COLLISION_ITEMS),A_Flags+DeadEnemy(a6)
 lea GrassHopperDead_Update(pc),a0
 move.l a0,A_pUpdate+DeadEnemy(a6)
 move.w d6,A_x+DeadEnemy(a6)
 move.w d7,A_y+DeadEnemy(a6)
 addq.w #8,A_y+DeadEnemy(a6)
 clr.l A_XSpeed+DeadEnemy(a6)
 move.l #20000,A_YSpeed+DeadEnemy(a6)
 move.w #16,A_Width+DeadEnemy(a6)
 move.w #8,A_Height+DeadEnemy(a6)
 lea GrassHopperDead0(pc),a0
 move.l a0,A_Data+DeadEnemy(a6)
 move.w #120,A_Data+4+DeadEnemy(a6)
 bra \30
\20:
 btst #AS_INVICIBLE,A_State+Actors(a6)
 bne \15
 tst.w A_Data+2+Actors(a6)
 bne \30
 bset #AS_DAMAGED,A_State+Actors(a6)
\30:
 lea GrassHopper0(pc),a4
 move.w uTime+2(a6),d0
 and.w #$20,d0
 add.w d0,a4
 bra Sprite2x2_Draw

GrassHopperDead_Update:
 tst.w A_Data+4(a5)
 beq \0
 subq.w #1,A_Data+4(a5)
 bne \0
 lea GrassHopperDead1(pc),a0
 move.l a0,A_Data(a5)
 bclr #AF_COLLISION_ITEMS,A_Flags(a5)
 move.l #40000,A_XSpeed(a5)
 move.l #-150000,A_YSpeed(a5)
\0: 
 move.l A_YSpeed(a5),d0
 add.l #6000,d0
 cmp.l #100000,d0
 blt \1
 move.l #100000,d0
\1: 
 move.l d0,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 move.l A_Data(a5),a4
 bra Sprite1x2_Draw

Bee_Update:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 subq.w #1,A_Data(a5)
 bpl \10
 tst.l A_XSpeed(a5)
 beq \5
 clr.l A_XSpeed(a5)
 move.w #120,A_Data(a5)
 lea EnemyBullets(a6),a0
 btst #AF_INUSE,A_Flags(a0)
 beq \0
 add.w #sACTOR,a0
\0:
 move.b #AFS_INUSE,A_Flags(a0)
 lea Arrow_Update(pc),a1
 move.l a1,A_pUpdate(a0)
 move.w d6,A_x(a0)
 move.w d7,A_y(a0)
 move.w #8,A_Width(a0)
 move.w #16,A_Height(a0)
 clr.l A_XSpeed(a0)
 move.l #30000,A_YSpeed(a0)
 bra \10
\5:
 move.l #-20000,A_XSpeed(a5)
 move.w #100,A_Data(a5)
\10:

 bclr #AS_DAMAGED,A_State(a5)
 bne \15
 tst.l pCollisionActor(a6)
 beq \30
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w A_y(a5),d0
 cmp.w #3,d0
 bgt \20
 tst.l A_YSpeed+Actors(a6)
 blt \20
 move.l #-100000,A_YSpeed+Actors(a6)
\15:
 bsr FloatingScore400_Create
 bclr #AF_INUSE,A_Flags(a5)
 move.b #(AFS_INUSE+AFS_COLLISION_ITEMS),A_Flags+DeadEnemy(a6)
 lea BeeDead_Update(pc),a0
 move.l a0,A_pUpdate+DeadEnemy(a6)
 move.w d6,A_x+DeadEnemy(a6)
 move.w d7,A_y+DeadEnemy(a6)
 addq.w #8,A_y+DeadEnemy(a6)
 clr.l A_XSpeed+DeadEnemy(a6)
 move.l #20000,A_YSpeed+DeadEnemy(a6)
 move.w #16,A_Width+DeadEnemy(a6)
 move.w #8,A_Height+DeadEnemy(a6)
 bra \30
\20:
 btst #AS_INVICIBLE,A_State+Actors(a6)
 bne \15
 tst.w A_Data+2+Actors(a6)
 bne \30
 bset #AS_DAMAGED,A_State+Actors(a6)
\30:
 
 lea Bee0(pc),a4
 move.w uTime+2(a6),d0
 and.w #$20,d0
 add.w d0,a4
 bra Sprite2x2_Draw

BeeDead_Update:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea BeeDead(pc),a4
 bra Sprite1x2_Draw

Arrow_Update:
 tst.l pCollisionActor(a6)
 beq \0
 tst.w A_Data+2+Actors(a6)
 bne \0
 bset #AS_DAMAGED,A_State+Actors(a6)
 bclr #AF_INUSE,A_Flags(a5)
\0:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea Arrow(pc),a4
 bra Sprite2x1_Draw

Tulip_Update:
 tst.l pCollisionActor(a6)
 beq \0
 tst.w A_Data+2+Actors(a6)
 bne \0
 bset #AS_DAMAGED,A_State+Actors(a6)
\0:

 lea Tulip0(pc),a4
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 tst.l A_YSpeed(a5)
 beq \20
 blt \10
 move.w A_Data(a5),d0
 add.w #$10,d0
 cmp.w d0,d7
 blt \11
 move.w d0,A_y(a5)
 clr.l A_YSpeed(a5)
 move.w #180,A_Data+2(a5)
 rts
\10:
 move.w A_Data(a5),d0
 cmp.w d0,d7
 bgt \11
 move.w d0,d7
 move.w d0,A_y(a5)
 clr.l A_YSpeed(a5)
 move.w #180,A_Data+2(a5)
\11:
 lea -32(a7),a7
 move.l a7,a0
 moveq #7,d0
\12:
 clr.l (a0)+
 dbra d0,\12
 move.l a7,a0
 moveq #$f,d0
 sub.w d7,d0
 add.w A_Data(a5),d0
\13:
 move.b $10(a4),$10(a0) 
 move.b (a4)+,(a0)+
 dbra d0,\13
 move.l a7,a4
 bsr Sprite2x2_Draw
 lea 32(a7),a7
 rts 
\20:
 cmp.w A_Data(a5),d7
 beq \30
 move.w A_x+Actors(a6),d0
 add.w A_Width+Actors(a6),d0
 sub.w d6,d0
 cmp.w #-8,d0
 blt \21
 move.w A_x+Actors(a6),d0
 sub.w d6,d0
 cmp.w #24,d0
 ble \22
\21:
 subq.w #1,A_Data+2(a5)
 bne \22
 move.l #-20000,A_YSpeed(a5)
\22:
 rts
\30:
 subq.w #1,A_Data+2(a5)
 bne \31
 move.l #20000,A_YSpeed(a5)
\31:
 move.w A_Data+2(a5),d0
 and.w #$20,d0
 add.w d0,a4
 bra Sprite2x2_Draw

RockFalling_Update:
 tst.l pCollisionActor(a6)
 beq \0
 tst.w A_Data+2+Actors(a6)
 bne \0
 bset #AS_DAMAGED,A_State+Actors(a6)
\0:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea BlockSolid006Left(pc),a4
 bra Sprite1x2_Draw

SphynxFire_Update:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 tst.l pCollisionActor(a6)
 beq \30
 move.w A_y+Actors(a6),d0
 add.w A_Height+Actors(a6),d0
 sub.w d7,d0
 cmp.w #3,d0
 bgt \20
 tst.l A_YSpeed+Actors(a6)
 blt \20
 move.l #-100000,A_YSpeed+Actors(a6)
\15:
 bsr FloatingScore400_Create
 bclr #AF_INUSE,A_Flags(a5)
 move.b #(AFS_INUSE+AFS_COLLISION_ITEMS),A_Flags+DeadEnemy(a6)
 lea SphynxFireDead_Update(pc),a0
 move.l a0,A_pUpdate+DeadEnemy(a6)
 move.w d6,A_x+DeadEnemy(a6)
 move.w d7,A_y+DeadEnemy(a6)
 addq.w #8,A_y+DeadEnemy(a6)
 clr.l A_XSpeed+DeadEnemy(a6)
 move.l #20000,A_YSpeed+DeadEnemy(a6)
 move.w #16,A_Width+DeadEnemy(a6)
 move.w #8,A_Height+DeadEnemy(a6)
 move.w #120,A_Data+4+DeadEnemy(a6)
 bra \30
\20:
 btst #AS_INVICIBLE,A_State+Actors(a6)
 bne \15
 tst.w A_Data+2+Actors(a6)
 bne \30
 bset #AS_DAMAGED,A_State+Actors(a6)
\30:

 btst #AF_INUSE,A_Flags+EnemyBullets(a6)
 bne \50
 move.b #AFS_INUSE,A_Flags+EnemyBullets(a6)
 lea FireBall_Update(pc),a1
 move.l a1,A_pUpdate+EnemyBullets(a6)
 move.w d6,A_x+EnemyBullets(a6)
 move.w d7,A_y+EnemyBullets(a6)
 move.w #8,A_Width+EnemyBullets(a6)
 move.w #8,A_Height+EnemyBullets(a6)
 move.l #40000,A_XSpeed+EnemyBullets(a6)
 move.l #30000,A_YSpeed+EnemyBullets(a6)
 cmp.w A_x+Actors(a6),d6
 blt \40
 neg.l A_XSpeed+EnemyBullets(a6)
\40:
 cmp.w A_y+Actors(a6),d7
 blt \41
 neg.l A_YSpeed+EnemyBullets(a6)
\41:
 move.b #50,A_Data(a5)
\50:
 lea SphynxFire0(pc),a4
 tst.b A_Data(a5)
 beq \51
 subq.b #1,A_Data(a5)
 add.w #$20,a4
\51:
 bra Sprite2x2_Draw

SphynxFireDead_Update:
 tst.w A_Data+4(a5)
 beq \0
 subq.w #1,A_Data+4(a5)
 bne \0
 bclr #AF_COLLISION_ITEMS,A_Flags(a5)
 move.l #40000,A_XSpeed(a5)
 move.l #-150000,A_YSpeed(a5)
\0: 
 move.l A_YSpeed(a5),d0
 add.l #6000,d0
 cmp.l #100000,d0
 blt \1
 move.l #100000,d0
\1: 
 move.l d0,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea SphynxFireDead(pc),a4
 bra Sprite1x2_Draw

FireBall_Update:
 tst.l pCollisionActor(a6)
 beq \0
 tst.w A_Data+2+Actors(a6)
 bne \0
 bset #AS_DAMAGED,A_State+Actors(a6)
 bclr #AF_INUSE,A_Flags(a5)
\0:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea FireBall(pc),a4
 bra Sprite_Draw

Lion_Update:
 tst.l pCollisionActor(a6)
 beq \0
 tst.w A_Data+2+Actors(a6)
 bne \0
 bset #AS_DAMAGED,A_State+Actors(a6)
\0:

 move.l A_YSpeed(a5),d0
 add.l #1000,d0
 cmp.l #30000,d0
 blt \1
 move.l #30000,d0
\1: 
 move.l d0,A_YSpeed(a5)
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 move.b A_Data(a5),d5
 lea Lion1LeftUp(pc),a4
 cmp.b #0,d5
 bne \10
 btst #AF_INUSE,A_Flags+EnemyBullets(a6)
 bne \40
 move.b #AFS_INUSE,A_Flags+EnemyBullets(a6)
 lea FireBallBig_Update(pc),a1
 move.l a1,A_pUpdate+EnemyBullets(a6)
 move.w d6,A_x+EnemyBullets(a6)
 move.w d7,A_y+EnemyBullets(a6)
 add.w #16,A_y+EnemyBullets(a6)
 move.w #16,A_Width+EnemyBullets(a6)
 move.w #8,A_Height+EnemyBullets(a6)
 move.l #-40000,A_XSpeed+EnemyBullets(a6)
 clr.l A_YSpeed+EnemyBullets(a6)
 moveq #1,d5
 bra \40 
\10:
 cmp.b #1,d5
 bne \20
 btst #AF_INUSE,A_Flags+EnemyBullets+sACTOR(a6)
 bne \40
 move.l #-50000,A_YSpeed(a5)
 moveq #2,d5
 bra \40
\20:
 lea Lion2LeftUp(pc),a4
 cmp.b #2,d5
 bne \30
 tst.l A_YSpeed(a5)
 blt \40
 move.b #AFS_INUSE,A_Flags+EnemyBullets+sACTOR(a6)
 lea FireBallBig_Update(pc),a1
 move.l a1,A_pUpdate+EnemyBullets+sACTOR(a6)
 move.w d6,A_x+EnemyBullets+sACTOR(a6)
 move.w d7,A_y+EnemyBullets+sACTOR(a6)
 add.w #16,A_y+EnemyBullets+sACTOR(a6)
 move.w #16,A_Width+EnemyBullets+sACTOR(a6)
 move.w #8,A_Height+EnemyBullets+sACTOR(a6)
 move.l #-40000,A_XSpeed+EnemyBullets+sACTOR(a6)
 clr.l A_YSpeed+EnemyBullets+sACTOR(a6)
 moveq #3,d5
 bra \40
\30:
 tst.b bCollisionY(a6)
 beq \40
 clr.b d5
\40: 
 move.b d5,A_Data(a5)
 bsr Sprite2x2_Draw
 subq.w #8,d6
 addq.w #8,d7
 bsr Sprite1x2_Draw
 addq.w #8,d6 
 subq.w #8,d7
 bsr Sprite2x1_Draw
 addq.w #8,d6
 subq.w #8,d7
 bra Sprite_Draw

FireBallBig_Update:
 tst.l pCollisionActor(a6)
 beq \0
 tst.w A_Data+2+Actors(a6)
 bne \0
 bset #AS_DAMAGED,A_State+Actors(a6)
 bclr #AF_INUSE,A_Flags(a5)
\0:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea FireBallBig(pc),a4
 bra Sprite1x2_Draw
 
; (d6.w,d7.w)  : (x,y)
; a0 : sprite
FloatingScore_Create:
 move.w d6,A_x+FloatingScore(a6)
 move.w d7,A_y+FloatingScore(a6)
 move.l a0,A_Data+FloatingScore(a6)
 bset #AF_INUSE,A_Flags+FloatingScore(a6)
 lea FloatingScore_Update(pc),a0
 move.l a0,A_pUpdate+FloatingScore(a6)
 move.l #-20000,A_YSpeed+FloatingScore(a6)
 rts

FloatingScore100_Create:
 add.l #100,uScore(a6)
 lea FloatingScore100(pc),a0
 bra FloatingScore_Create

FloatingScore400_Create:
 add.l #400,uScore(a6)
 lea FloatingScore400(pc),a0
 bra FloatingScore_Create

FloatingScore1000_Create:
 add.l #1000,uScore(a6)
 lea FloatingScore1000(pc),a0
 bra FloatingScore_Create

FloatingScore1Up_Create:
 addq.w #1,wLives(a6)
 lea FloatingScore1Up(pc),a0
 bra FloatingScore_Create

FloatingScore_Update:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 move.l A_Data(a5),a4
 bra Sprite1x2_Draw

Bullet_Update:
 move.w A_x(a5),d0
 sub.w wScrollingX(a6),d0
 cmp.w #160,d0
 blt \0
 bclr #AF_INUSE,A_Flags(a5)
\0:
 tst.b bCollisionX(a6)
 beq \10
 neg.l A_XSpeed(a5)
\10:
 tst.b bCollisionY(a6)
 beq \11
 neg.l A_YSpeed(a5)
\11:
 move.l pCollisionActor(a6),a0
 cmp.w #0,a0
 beq \20
 btst #AF_DAMAGED_ON_BULLET,A_Flags(a0)
 beq \20
 bset #AS_DAMAGED,A_State(a0)
 bclr #AF_INUSE,A_Flags(a5)
\20:
 move.w A_x(a5),d6
 move.w A_y(a5),d7
 lea Bullet0(pc),a4
 bra Sprite_Draw
 
